Config (apache-cassandra API)
Date: 2018-02-14

org.apache.cassandra.config

## Class Config

- java.lang.Object
- - org.apache.cassandra.config.Config

-     public class Config
      extends java.lang.Object

  A class that contains configuration properties for the cassandra node it runs within. Properties declared as volatile can be mutated via JMX.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `Config.CommitFailurePolicy`
    `static class` | `Config.CommitLogSync`
    `static class` | `Config.DiskAccessMode`
    `static class` | `Config.DiskFailurePolicy`
    `static class` | `Config.DiskOptimizationStrategy`
    `static class` | `Config.InternodeCompression`
    `static class` | `Config.MemtableAllocationType`
    `static class` | `Config.RequestSchedulerId`
    `static class` | `Config.UserFunctionTimeoutPolicy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `java.lang.String` | `allocate_tokens_for_keyspace` Triggers automatic allocation of tokens if set, using the replication strategy of the referenced keyspace
    `java.lang.String` | `authenticator`
    `java.lang.String` | `authorizer`
    `boolean` | `auto_bootstrap`
    `boolean` | `auto_snapshot`
    `boolean` | `back_pressure_enabled`
    `ParameterizedClass` | `back_pressure_strategy`
    `int` | `batch_size_fail_threshold_in_kb`
    `int` | `batch_size_warn_threshold_in_kb`
    `int` | `batchlog_replay_throttle_in_kb`
    `java.lang.String` | `broadcast_address`
    `java.lang.String` | `broadcast_rpc_address`
    `boolean` | `buffer_pool_use_heap_if_exhausted`
    `long` | `cas_contention_timeout_in_ms`
    `boolean` | `cdc_enabled`
    `int` | `cdc_free_space_check_interval_ms`
    `java.lang.String` | `cdc_raw_directory`
    `int` | `cdc_total_space_in_mb`
    `EncryptionOptions.ClientEncryptionOptions` | `client_encryption_options`
    `java.lang.String` | `cluster_name`
    `int` | `column_index_cache_size_in_kb`
    `int` | `column_index_size_in_kb`
    `Config.CommitFailurePolicy` | `commit_failure_policy`
    `ParameterizedClass` | `commitlog_compression`
    `java.lang.String` | `commitlog_directory`
    `int` | `commitlog_max_compression_buffers_in_pool`
    `int` | `commitlog_periodic_queue_size` Deprecated.
    `int` | `commitlog_segment_size_in_mb`
    `Config.CommitLogSync` | `commitlog_sync`
    `double` | `commitlog_sync_batch_window_in_ms`
    `int` | `commitlog_sync_period_in_ms`
    `java.lang.Integer` | `commitlog_total_space_in_mb`
    `int` | `compaction_large_partition_warning_threshold_mb`
    `int` | `compaction_throughput_mb_per_sec`
    `java.lang.Integer` | `concurrent_compactors`
    `int` | `concurrent_counter_writes`
    `int` | `concurrent_materialized_view_writes`
    `int` | `concurrent_reads`
    `java.lang.Integer` | `concurrent_replicates` Deprecated.
    `int` | `concurrent_writes`
    `int` | `counter_cache_keys_to_save`
    `int` | `counter_cache_save_period`
    `java.lang.Long` | `counter_cache_size_in_mb`
    `long` | `counter_write_request_timeout_in_ms`
    `int` | `credentials_cache_max_entries`
    `int` | `credentials_update_interval_in_ms`
    `int` | `credentials_validity_in_ms`
    `boolean` | `cross_node_timeout`
    `java.lang.String[]` | `data_file_directories`
    `Config.DiskAccessMode` | `disk_access_mode`
    `Config.DiskFailurePolicy` | `disk_failure_policy`
    `double` | `disk_optimization_estimate_percentile`
    `double` | `disk_optimization_page_cross_chance`
    `Config.DiskOptimizationStrategy` | `disk_optimization_strategy`
    `boolean` | `dynamic_snitch`
    `double` | `dynamic_snitch_badness_threshold`
    `int` | `dynamic_snitch_reset_interval_in_ms`
    `int` | `dynamic_snitch_update_interval_in_ms`
    `boolean` | `enable_materialized_views`
    `boolean` | `enable_scripted_user_defined_functions`
    `boolean` | `enable_user_defined_functions`
    `boolean` | `enable_user_defined_functions_threads` Optionally disable asynchronous UDF execution.
    `EncryptionOptions.ServerEncryptionOptions` | `encryption_options`
    `java.lang.String` | `endpoint_snitch`
    `java.lang.Boolean` | `file_cache_round_up` Because of the current `BufferPool` slab sizes of 64 kb, we store in the file cache buffers that divide 64 kb, so we need to round the buffer sizes to powers of two.
    `java.lang.Integer` | `file_cache_size_in_mb`
    `int` | `gc_log_threshold_in_ms`
    `int` | `gc_warn_threshold_in_ms`
    `java.util.Set<java.lang.String>` | `hinted_handoff_disabled_datacenters`
    `boolean` | `hinted_handoff_enabled`
    `int` | `hinted_handoff_throttle_in_kb`
    `ParameterizedClass` | `hints_compression`
    `java.lang.String` | `hints_directory`
    `int` | `hints_flush_period_in_ms`
    `boolean` | `incremental_backups`
    `java.lang.Integer` | `index_interval` Deprecated.
    `java.lang.Long` | `index_summary_capacity_in_mb`
    `int` | `index_summary_resize_interval_in_minutes`
    `java.lang.String` | `initial_token`
    `int` | `inter_dc_stream_throughput_outbound_megabits_per_sec`
    `boolean` | `inter_dc_tcp_nodelay`
    `java.lang.String` | `internode_authenticator`
    `Config.InternodeCompression` | `internode_compression`
    `int` | `internode_recv_buff_size_in_bytes`
    `int` | `internode_send_buff_size_in_bytes`
    `int` | `key_cache_keys_to_save`
    `int` | `key_cache_save_period`
    `java.lang.Long` | `key_cache_size_in_mb`
    `java.lang.String` | `listen_address`
    `java.lang.String` | `listen_interface`
    `boolean` | `listen_interface_prefer_ipv6`
    `boolean` | `listen_on_broadcast_address`
    `int` | `max_hint_window_in_ms`
    `int` | `max_hints_delivery_threads`
    `int` | `max_hints_file_size_in_mb`
    `java.lang.Integer` | `max_mutation_size_in_kb`
    `int` | `max_streaming_retries` Deprecated. retry support removed on CASSANDRA-10992
    `int` | `max_value_size_in_mb` Max size of values in SSTables, in MegaBytes.
    `Config.MemtableAllocationType` | `memtable_allocation_type`
    `java.lang.Float` | `memtable_cleanup_threshold`
    `int` | `memtable_flush_writers`
    `java.lang.Integer` | `memtable_heap_space_in_mb`
    `java.lang.Integer` | `memtable_offheap_space_in_mb`
    `int` | `min_free_space_per_drive_in_mb`
    `long` | `native_transport_max_concurrent_connections`
    `long` | `native_transport_max_concurrent_connections_per_ip`
    `int` | `native_transport_max_frame_size_in_mb`
    `int` | `native_transport_max_threads`
    `int` | `native_transport_port`
    `java.lang.Integer` | `native_transport_port_ssl`
    `int` | `num_tokens`
    `int` | `otc_backlog_expiration_interval_ms`
    `static int` | `otc_backlog_expiration_interval_ms_default` Backlog expiration interval in milliseconds for the OutboundTcpConnection.
    `int` | `otc_coalescing_enough_coalesced_messages`
    `java.lang.String` | `otc_coalescing_strategy`
    `int` | `otc_coalescing_window_us`
    `static int` | `otc_coalescing_window_us_default`
    `java.lang.String` | `partitioner`
    `int` | `permissions_cache_max_entries`
    `int` | `permissions_update_interval_in_ms`
    `int` | `permissions_validity_in_ms`
    `double` | `phi_convict_threshold`
    `java.lang.Long` | `prepared_statements_cache_size_mb` Size of the CQL prepared statements cache in MB.
    `static java.lang.String` | `PROPERTY_PREFIX`
    `long` | `range_request_timeout_in_ms`
    `long` | `read_request_timeout_in_ms`
    `java.lang.String` | `request_scheduler`
    `Config.RequestSchedulerId` | `request_scheduler_id`
    `RequestSchedulerOptions` | `request_scheduler_options`
    `long` | `request_timeout_in_ms`
    `java.lang.String` | `role_manager`
    `int` | `roles_cache_max_entries`
    `int` | `roles_update_interval_in_ms`
    `int` | `roles_validity_in_ms`
    `java.lang.String` | `row_cache_class_name`
    `int` | `row_cache_keys_to_save`
    `int` | `row_cache_save_period`
    `long` | `row_cache_size_in_mb`
    `java.lang.String` | `rpc_address`
    `java.lang.String` | `rpc_interface`
    `boolean` | `rpc_interface_prefer_ipv6`
    `boolean` | `rpc_keepalive`
    `int` | `rpc_listen_backlog`
    `int` | `rpc_max_threads`
    `int` | `rpc_min_threads`
    `int` | `rpc_port`
    `java.lang.Integer` | `rpc_recv_buff_size_in_bytes`
    `java.lang.Integer` | `rpc_send_buff_size_in_bytes`
    `java.lang.String` | `rpc_server_type`
    `java.lang.String` | `saved_caches_directory`
    `ParameterizedClass` | `seed_provider`
    `EncryptionOptions.ServerEncryptionOptions` | `server_encryption_options`
    `long` | `slow_query_log_timeout_in_ms`
    `boolean` | `snapshot_before_compaction`
    `int` | `ssl_storage_port`
    `int` | `sstable_preemptive_open_interval_in_mb`
    `boolean` | `start_native_transport`
    `boolean` | `start_rpc`
    `int` | `storage_port`
    `int` | `stream_throughput_outbound_megabits_per_sec`
    `java.lang.Integer` | `streaming_keep_alive_period_in_secs`
    `int` | `streaming_socket_timeout_in_ms` Deprecated. use `this#streaming_keep_alive_period_in_secs` instead
    `int` | `thrift_framed_transport_size_in_mb`
    `int` | `thrift_max_message_length_in_mb` Deprecated.
    `java.lang.Long` | `thrift_prepared_statements_cache_size_mb` Size of the Thrift prepared statements cache in MB.
    `int` | `tombstone_failure_threshold`
    `int` | `tombstone_warn_threshold`
    `int` | `tracetype_query_ttl`
    `int` | `tracetype_repair_ttl`
    `TransparentDataEncryptionOptions` | `transparent_data_encryption_options`
    `boolean` | `trickle_fsync`
    `int` | `trickle_fsync_interval_in_kb`
    `long` | `truncate_request_timeout_in_ms`
    `java.lang.Integer` | `unlogged_batch_across_partitions_warn_threshold`
    `long` | `user_defined_function_fail_timeout` Time in milliseconds after a fatal UDF run-time situation is detected and action according to user_function_timeout_policy will take place.
    `long` | `user_defined_function_warn_timeout` Time in milliseconds after a warning will be emitted to the log and to the client that a UDF runs too long.
    `Config.UserFunctionTimeoutPolicy` | `user_function_timeout_policy` Defines what to do when a UDF ran longer than user_defined_function_fail_timeout.
    `int` | `windows_timer_interval`
    `long` | `write_request_timeout_in_ms`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Config()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `isClientMode()` Deprecated. migrate to `DatabaseDescriptor.isClientInitialized()`
    `static void` | `log(Config config)`
    `static void` | `setClientMode(boolean clientMode)` Deprecated. migrate to `DatabaseDescriptor.clientInitialization(boolean)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### PROPERTY_PREFIX

          public static final java.lang.String PROPERTY_PREFIX

      See Also:
        Constant Field Values

    - #### cluster_name

          public java.lang.String cluster_name

    - #### authenticator

          public java.lang.String authenticator

    - #### authorizer

          public java.lang.String authorizer

    - #### role_manager

          public java.lang.String role_manager

    - #### permissions_validity_in_ms

          public volatile int permissions_validity_in_ms

    - #### permissions_cache_max_entries

          public volatile int permissions_cache_max_entries

    - #### permissions_update_interval_in_ms

          public volatile int permissions_update_interval_in_ms

    - #### roles_validity_in_ms

          public volatile int roles_validity_in_ms

    - #### roles_cache_max_entries

          public volatile int roles_cache_max_entries

    - #### roles_update_interval_in_ms

          public volatile int roles_update_interval_in_ms

    - #### credentials_validity_in_ms

          public volatile int credentials_validity_in_ms

    - #### credentials_cache_max_entries

          public volatile int credentials_cache_max_entries

    - #### credentials_update_interval_in_ms

          public volatile int credentials_update_interval_in_ms

    - #### partitioner

          public java.lang.String partitioner

    - #### auto_bootstrap

          public boolean auto_bootstrap

    - #### hinted_handoff_enabled

          public volatile boolean hinted_handoff_enabled

    - #### hinted_handoff_disabled_datacenters

          public java.util.Set<java.lang.String> hinted_handoff_disabled_datacenters

    - #### max_hint_window_in_ms

          public volatile int max_hint_window_in_ms

    - #### hints_directory

          public java.lang.String hints_directory

    - #### seed_provider

          public ParameterizedClass seed_provider

    - #### disk_access_mode

          public Config.DiskAccessMode disk_access_mode

    - #### disk_failure_policy

          public Config.DiskFailurePolicy disk_failure_policy

    - #### commit_failure_policy

          public Config.CommitFailurePolicy commit_failure_policy

    - #### initial_token

          public java.lang.String initial_token

    - #### num_tokens

          public int num_tokens

    - #### allocate_tokens_for_keyspace

          public java.lang.String allocate_tokens_for_keyspace

      Triggers automatic allocation of tokens if set, using the replication strategy of the referenced keyspace

    - #### request_timeout_in_ms

          public volatile long request_timeout_in_ms

    - #### read_request_timeout_in_ms

          public volatile long read_request_timeout_in_ms

    - #### range_request_timeout_in_ms

          public volatile long range_request_timeout_in_ms

    - #### write_request_timeout_in_ms

          public volatile long write_request_timeout_in_ms

    - #### counter_write_request_timeout_in_ms

          public volatile long counter_write_request_timeout_in_ms

    - #### cas_contention_timeout_in_ms

          public volatile long cas_contention_timeout_in_ms

    - #### truncate_request_timeout_in_ms

          public volatile long truncate_request_timeout_in_ms

    - #### streaming_socket_timeout_in_ms

          @Deprecated
          public int streaming_socket_timeout_in_ms

      Deprecated. use `this#streaming_keep_alive_period_in_secs` instead

    - #### streaming_keep_alive_period_in_secs

          public java.lang.Integer streaming_keep_alive_period_in_secs

    - #### cross_node_timeout

          public boolean cross_node_timeout

    - #### slow_query_log_timeout_in_ms

          public volatile long slow_query_log_timeout_in_ms

    - #### phi_convict_threshold

          public volatile double phi_convict_threshold

    - #### concurrent_reads

          public int concurrent_reads

    - #### concurrent_writes

          public int concurrent_writes

    - #### concurrent_counter_writes

          public int concurrent_counter_writes

    - #### concurrent_materialized_view_writes

          public int concurrent_materialized_view_writes

    - #### concurrent_replicates

          @Deprecated
          public java.lang.Integer concurrent_replicates

      Deprecated.

    - #### memtable_flush_writers

          public int memtable_flush_writers

    - #### memtable_heap_space_in_mb

          public java.lang.Integer memtable_heap_space_in_mb

    - #### memtable_offheap_space_in_mb

          public java.lang.Integer memtable_offheap_space_in_mb

    - #### memtable_cleanup_threshold

          public java.lang.Float memtable_cleanup_threshold

    - #### storage_port

          public int storage_port

    - #### ssl_storage_port

          public int ssl_storage_port

    - #### listen_address

          public java.lang.String listen_address

    - #### listen_interface

          public java.lang.String listen_interface

    - #### listen_interface_prefer_ipv6

          public boolean listen_interface_prefer_ipv6

    - #### broadcast_address

          public java.lang.String broadcast_address

    - #### listen_on_broadcast_address

          public boolean listen_on_broadcast_address

    - #### internode_authenticator

          public java.lang.String internode_authenticator

    - #### start_rpc

          public boolean start_rpc

    - #### rpc_address

          public java.lang.String rpc_address

    - #### rpc_interface

          public java.lang.String rpc_interface

    - #### rpc_interface_prefer_ipv6

          public boolean rpc_interface_prefer_ipv6

    - #### broadcast_rpc_address

          public java.lang.String broadcast_rpc_address

    - #### rpc_port

          public int rpc_port

    - #### rpc_listen_backlog

          public int rpc_listen_backlog

    - #### rpc_server_type

          public java.lang.String rpc_server_type

    - #### rpc_keepalive

          public boolean rpc_keepalive

    - #### rpc_min_threads

          public int rpc_min_threads

    - #### rpc_max_threads

          public int rpc_max_threads

    - #### rpc_send_buff_size_in_bytes

          public java.lang.Integer rpc_send_buff_size_in_bytes

    - #### rpc_recv_buff_size_in_bytes

          public java.lang.Integer rpc_recv_buff_size_in_bytes

    - #### internode_send_buff_size_in_bytes

          public int internode_send_buff_size_in_bytes

    - #### internode_recv_buff_size_in_bytes

          public int internode_recv_buff_size_in_bytes

    - #### start_native_transport

          public boolean start_native_transport

    - #### native_transport_port

          public int native_transport_port

    - #### native_transport_port_ssl

          public java.lang.Integer native_transport_port_ssl

    - #### native_transport_max_threads

          public int native_transport_max_threads

    - #### native_transport_max_frame_size_in_mb

          public int native_transport_max_frame_size_in_mb

    - #### native_transport_max_concurrent_connections

          public volatile long native_transport_max_concurrent_connections

    - #### native_transport_max_concurrent_connections_per_ip

          public volatile long native_transport_max_concurrent_connections_per_ip

    - #### thrift_max_message_length_in_mb

          @Deprecated
          public int thrift_max_message_length_in_mb

      Deprecated.

    - #### max_value_size_in_mb

          public int max_value_size_in_mb

      Max size of values in SSTables, in MegaBytes. Default is the same as the native protocol frame limit: 256Mb. See AbstractType for how it is used.

    - #### thrift_framed_transport_size_in_mb

          public int thrift_framed_transport_size_in_mb

    - #### snapshot_before_compaction

          public boolean snapshot_before_compaction

    - #### auto_snapshot

          public boolean auto_snapshot

    - #### column_index_size_in_kb

          public int column_index_size_in_kb

    - #### column_index_cache_size_in_kb

          public int column_index_cache_size_in_kb

    - #### batch_size_warn_threshold_in_kb

          public volatile int batch_size_warn_threshold_in_kb

    - #### batch_size_fail_threshold_in_kb

          public volatile int batch_size_fail_threshold_in_kb

    - #### unlogged_batch_across_partitions_warn_threshold

          public java.lang.Integer unlogged_batch_across_partitions_warn_threshold

    - #### concurrent_compactors

          public volatile java.lang.Integer concurrent_compactors

    - #### compaction_throughput_mb_per_sec

          public volatile int compaction_throughput_mb_per_sec

    - #### compaction_large_partition_warning_threshold_mb

          public volatile int compaction_large_partition_warning_threshold_mb

    - #### min_free_space_per_drive_in_mb

          public int min_free_space_per_drive_in_mb

    - #### max_streaming_retries

          @Deprecated
          public int max_streaming_retries

      Deprecated. retry support removed on CASSANDRA-10992

    - #### stream_throughput_outbound_megabits_per_sec

          public volatile int stream_throughput_outbound_megabits_per_sec

    - #### inter_dc_stream_throughput_outbound_megabits_per_sec

          public volatile int inter_dc_stream_throughput_outbound_megabits_per_sec

    - #### data_file_directories

          public java.lang.String[] data_file_directories

    - #### saved_caches_directory

          public java.lang.String saved_caches_directory

    - #### commitlog_directory

          public java.lang.String commitlog_directory

    - #### commitlog_total_space_in_mb

          public java.lang.Integer commitlog_total_space_in_mb

    - #### commitlog_sync

          public Config.CommitLogSync commitlog_sync

    - #### commitlog_sync_batch_window_in_ms

          public double commitlog_sync_batch_window_in_ms

    - #### commitlog_sync_period_in_ms

          public int commitlog_sync_period_in_ms

    - #### commitlog_segment_size_in_mb

          public int commitlog_segment_size_in_mb

    - #### commitlog_compression

          public ParameterizedClass commitlog_compression

    - #### commitlog_max_compression_buffers_in_pool

          public int commitlog_max_compression_buffers_in_pool

    - #### transparent_data_encryption_options

          public TransparentDataEncryptionOptions transparent_data_encryption_options

    - #### max_mutation_size_in_kb

          public java.lang.Integer max_mutation_size_in_kb

    - #### cdc_enabled

          public boolean cdc_enabled

    - #### cdc_raw_directory

          public java.lang.String cdc_raw_directory

    - #### cdc_total_space_in_mb

          public int cdc_total_space_in_mb

    - #### cdc_free_space_check_interval_ms

          public int cdc_free_space_check_interval_ms

    - #### commitlog_periodic_queue_size

          @Deprecated
          public int commitlog_periodic_queue_size

      Deprecated.

    - #### endpoint_snitch

          public java.lang.String endpoint_snitch

    - #### dynamic_snitch

          public boolean dynamic_snitch

    - #### dynamic_snitch_update_interval_in_ms

          public int dynamic_snitch_update_interval_in_ms

    - #### dynamic_snitch_reset_interval_in_ms

          public int dynamic_snitch_reset_interval_in_ms

    - #### dynamic_snitch_badness_threshold

          public double dynamic_snitch_badness_threshold

    - #### request_scheduler

          public java.lang.String request_scheduler

    - #### request_scheduler_id

          public Config.RequestSchedulerId request_scheduler_id

    - #### request_scheduler_options

          public RequestSchedulerOptions request_scheduler_options

    - #### server_encryption_options

          public EncryptionOptions.ServerEncryptionOptions server_encryption_options

    - #### client_encryption_options

          public EncryptionOptions.ClientEncryptionOptions client_encryption_options

    - #### encryption_options

          public EncryptionOptions.ServerEncryptionOptions encryption_options

    - #### internode_compression

          public Config.InternodeCompression internode_compression

    - #### index_interval

          @Deprecated
          public java.lang.Integer index_interval

      Deprecated.

    - #### hinted_handoff_throttle_in_kb

          public int hinted_handoff_throttle_in_kb

    - #### batchlog_replay_throttle_in_kb

          public int batchlog_replay_throttle_in_kb

    - #### max_hints_delivery_threads

          public int max_hints_delivery_threads

    - #### hints_flush_period_in_ms

          public int hints_flush_period_in_ms

    - #### max_hints_file_size_in_mb

          public int max_hints_file_size_in_mb

    - #### hints_compression

          public ParameterizedClass hints_compression

    - #### sstable_preemptive_open_interval_in_mb

          public int sstable_preemptive_open_interval_in_mb

    - #### incremental_backups

          public volatile boolean incremental_backups

    - #### trickle_fsync

          public boolean trickle_fsync

    - #### trickle_fsync_interval_in_kb

          public int trickle_fsync_interval_in_kb

    - #### key_cache_size_in_mb

          public java.lang.Long key_cache_size_in_mb

    - #### key_cache_save_period

          public volatile int key_cache_save_period

    - #### key_cache_keys_to_save

          public volatile int key_cache_keys_to_save

    - #### row_cache_class_name

          public java.lang.String row_cache_class_name

    - #### row_cache_size_in_mb

          public long row_cache_size_in_mb

    - #### row_cache_save_period

          public volatile int row_cache_save_period

    - #### row_cache_keys_to_save

          public volatile int row_cache_keys_to_save

    - #### counter_cache_size_in_mb

          public java.lang.Long counter_cache_size_in_mb

    - #### counter_cache_save_period

          public volatile int counter_cache_save_period

    - #### counter_cache_keys_to_save

          public volatile int counter_cache_keys_to_save

    - #### file_cache_size_in_mb

          public java.lang.Integer file_cache_size_in_mb

    - #### file_cache_round_up

          public java.lang.Boolean file_cache_round_up

      Because of the current `BufferPool` slab sizes of 64 kb, we store in the file cache buffers that divide 64 kb, so we need to round the buffer sizes to powers of two. This boolean controls weather they are rounded up or down. Set it to true to round up to the next power of two, set it to false to round down to the previous power of two. Note that buffer sizes are already rounded to 4 kb and capped between 4 kb minimum and 64 kb maximum by the `Config.DiskOptimizationStrategy`. By default, this boolean is set to round down when `disk_optimization_strategy` is `ssd`, and to round up when it is `spinning`.

    - #### buffer_pool_use_heap_if_exhausted

          public boolean buffer_pool_use_heap_if_exhausted

    - #### disk_optimization_strategy

          public Config.DiskOptimizationStrategy disk_optimization_strategy

    - #### disk_optimization_estimate_percentile

          public double disk_optimization_estimate_percentile

    - #### disk_optimization_page_cross_chance

          public double disk_optimization_page_cross_chance

    - #### inter_dc_tcp_nodelay

          public boolean inter_dc_tcp_nodelay

    - #### memtable_allocation_type

          public Config.MemtableAllocationType memtable_allocation_type

    - #### tombstone_warn_threshold

          public volatile int tombstone_warn_threshold

    - #### tombstone_failure_threshold

          public volatile int tombstone_failure_threshold

    - #### index_summary_capacity_in_mb

          public volatile java.lang.Long index_summary_capacity_in_mb

    - #### index_summary_resize_interval_in_minutes

          public volatile int index_summary_resize_interval_in_minutes

    - #### gc_log_threshold_in_ms

          public int gc_log_threshold_in_ms

    - #### gc_warn_threshold_in_ms

          public int gc_warn_threshold_in_ms

    - #### tracetype_query_ttl

          public int tracetype_query_ttl

    - #### tracetype_repair_ttl

          public int tracetype_repair_ttl

    - #### otc_coalescing_strategy

          public java.lang.String otc_coalescing_strategy

    - #### otc_coalescing_window_us_default

          public static final int otc_coalescing_window_us_default

      See Also:
        Constant Field Values

    - #### otc_coalescing_window_us

          public int otc_coalescing_window_us

    - #### otc_coalescing_enough_coalesced_messages

          public int otc_coalescing_enough_coalesced_messages

    - #### otc_backlog_expiration_interval_ms_default

          public static final int otc_backlog_expiration_interval_ms_default

      Backlog expiration interval in milliseconds for the OutboundTcpConnection.
      See Also:
        Constant Field Values

    - #### otc_backlog_expiration_interval_ms

          public volatile int otc_backlog_expiration_interval_ms

    - #### windows_timer_interval

          public int windows_timer_interval

    - #### prepared_statements_cache_size_mb

          public java.lang.Long prepared_statements_cache_size_mb

      Size of the CQL prepared statements cache in MB. Defaults to 1/256th of the heap size or 10MB, whichever is greater.

    - #### thrift_prepared_statements_cache_size_mb

          public java.lang.Long thrift_prepared_statements_cache_size_mb

      Size of the Thrift prepared statements cache in MB. Defaults to 1/256th of the heap size or 10MB, whichever is greater.

    - #### enable_user_defined_functions

          public boolean enable_user_defined_functions

    - #### enable_scripted_user_defined_functions

          public boolean enable_scripted_user_defined_functions

    - #### enable_materialized_views

          public boolean enable_materialized_views

    - #### enable_user_defined_functions_threads

          public boolean enable_user_defined_functions_threads

      Optionally disable asynchronous UDF execution. Disabling asynchronous UDF execution also implicitly disables the security-manager! By default, async UDF execution is enabled to be able to detect UDFs that run too long / forever and be able to fail fast - i.e. stop the Cassandra daemon, which is currently the only appropriate approach to "tell" a user that there's something really wrong with the UDF. When you disable async UDF execution, users MUST pay attention to read-timeouts since these may indicate UDFs that run too long or forever - and this can destabilize the cluster.

    - #### user_defined_function_warn_timeout

          public long user_defined_function_warn_timeout

      Time in milliseconds after a warning will be emitted to the log and to the client that a UDF runs too long. (Only valid, if enable_user_defined_functions_threads==true)

    - #### user_defined_function_fail_timeout

          public long user_defined_function_fail_timeout

      Time in milliseconds after a fatal UDF run-time situation is detected and action according to user_function_timeout_policy will take place. (Only valid, if enable_user_defined_functions_threads==true)

    - #### user_function_timeout_policy

          public Config.UserFunctionTimeoutPolicy user_function_timeout_policy

      Defines what to do when a UDF ran longer than user_defined_function_fail_timeout. Possible options are: - 'die' - i.e. it is able to emit a warning to the client before the Cassandra Daemon will shut down. - 'die_immediate' - shut down C* daemon immediately (effectively prevent the chance that the client will receive a warning). - 'ignore' - just log - the most dangerous option. (Only valid, if enable_user_defined_functions_threads==true)

    - #### back_pressure_enabled

          public volatile boolean back_pressure_enabled

    - #### back_pressure_strategy

          public volatile ParameterizedClass back_pressure_strategy

  - ### Constructor Detail

    - #### Config

          public Config()

  - ### Method Detail

    - #### isClientMode

          @Deprecated
          public static boolean isClientMode()

      Deprecated. migrate to `DatabaseDescriptor.isClientInitialized()`

    - #### setClientMode

          @Deprecated
          public static void setClientMode(boolean clientMode)

      Deprecated. migrate to `DatabaseDescriptor.clientInitialization(boolean)`
      Client mode means that the process is a pure client, that uses C* code base but does not read or write local C* database files.

    - #### log

          public static void log(Config config)

Copyright © 2018 The Apache Software Foundation